﻿' -----------------------------------------------------------------------------------------
'
' MouseExplorerRI                                                   Ulrich Müller  01.10.10
'                                                                   Aspire  VB 2005 Express
' Robo Explorer mit Maussteuerung (Robo Interface Version)
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class MouseExplorerRI

	Dim ft As New FishFace()
	Dim canvas As Graphics
	Dim mouseX, mouseY As Integer
	Dim mitte, mitteOben, MitteUnten, mitteLinks, mitteRechts As Integer
	Dim Farbe As New SolidBrush(Color.Red)

	Private Function Speed(ByVal pos) As Speed
		pos = IIf(pos > mitteRechts, pos - mitteRechts, mitteLinks - pos)
		If pos > 45 Then Return Speed.Full
		If pos > 30 Then Return Speed.L5
		Return Speed.L3
	End Function
	Private Sub Action()
		Do
			canvas.Clear(Color.White)
			If mouseY < mitteOben And mouseX < mitteLinks Then								 ' --- LinksVor
				ft.SetMotor(Out.M1, Dir.Left, Speed(mouseX))
				ft.SetMotor(Out.M2, Dir.Left, Speed(mouseY))
				canvas.FillRectangle(Farbe, 0, 0, mitteLinks, mitteOben)
			ElseIf mouseY < mitteOben And mouseX < mitteRechts Then						 ' --- Vor
				ft.SetMotor(Out.M1, Dir.Left, Speed(mouseY))
				ft.SetMotor(Out.M2, Dir.Left, Speed(mouseY))
				canvas.FillRectangle(Farbe, mitteLinks, 0, mitte, mitteOben)
			ElseIf mouseY < mitteOben Then																		 ' --- RechtsVor
				ft.SetMotor(Out.M1, Dir.Left, Speed(mouseY))
				ft.SetMotor(Out.M2, Dir.Left, Speed(mouseX))
				canvas.FillRectangle(Farbe, mitteRechts, 0, mitteLinks, mitteOben)
			ElseIf mouseY < MitteUnten And mouseX < mitteLinks Then						 ' --- LinksDrehen
				ft.SetMotor(Out.M1, Dir.Left, Speed(mouseX))
				ft.SetMotor(Out.M2, Dir.Right, Speed(mouseX))
				canvas.FillRectangle(Farbe, 0, mitteLinks, mitteLinks, mitte)
			ElseIf mouseY < MitteUnten And mouseX < mitteRechts Then					 ' --- Halt
				ft.SetMotor(Out.M1, Dir.Off)
				ft.SetMotor(Out.M2, Dir.Off)
			ElseIf mouseY < MitteUnten Then																		 ' --- RechtsDrehen
				ft.SetMotor(Out.M1, Dir.Right, Speed(mouseX))
				ft.SetMotor(Out.M2, Dir.Left, Speed(mouseX))
				canvas.FillRectangle(Farbe, mitteRechts, mitteOben, mitteLinks, mitte)
			ElseIf mouseX < mitteLinks Then																		 ' --- LinksRuck
				ft.SetMotor(Out.M1, Dir.Right, Speed(mouseX))
				ft.SetMotor(Out.M2, Dir.Right, Speed(mouseY))
				canvas.FillRectangle(Farbe, 0, MitteUnten, mitteLinks, mitteOben)
			ElseIf mouseX < mitteRechts Then																	 ' --- Ruck
				ft.SetMotor(Out.M1, Dir.Right, Speed(mouseY))
				ft.SetMotor(Out.M2, Dir.Right, Speed(mouseY))
				canvas.FillRectangle(Farbe, mitteLinks, MitteUnten, mitte, mitteOben)
			Else																															 ' --- LinksRuck
				ft.SetMotor(Out.M1, Dir.Right, Speed(mouseY))
				ft.SetMotor(Out.M2, Dir.Right, Speed(mouseX))
				canvas.FillRectangle(Farbe, mitteRechts, MitteUnten, mitteLinks, mitteOben)
			End If
			ft.Pause(333)
		Loop Until ft.Finish()
	End Sub

#Region "--- ProgramControl ---"
    Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
    Handles cmdAction.Click
        ' --- Open erste ROBO Interface an USB oder Intelligent Interface an COM ---
        '     während des Ablaufs von Action gesperrt
        Try
            If cboPortName.SelectedIndex = 0 Then
                ft.OpenInterface(IFTypen.ftROBO_first_USB, 0)
            Else
                ft.OpenInterface(IFTypen.ftIntelligent_IF, cboPortName.SelectedIndex, 5)
            End If
            cmdAction.Enabled = False
            cmdEnde.Text = "&HALT"
            lblStatus.Text = "--- Bei der Arbeit ---"

            Action()          ' --- Nutz-Routine für die Anwendung

            ft.ClearMotors()
        Catch ex As FishFaceException
            MsgBox(ex.Message)
        Finally
            ft.CloseInterface()
            cmdAction.Enabled = True
            cmdEnde.Text = "&ENDE"
            lblStatus.Text = "--- Auf ein Neues ---"
            cmdEnde.Focus()
        End Try

    End Sub

    Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
        ' --- Programmende nur, wenn Action nicht läuft ---
        If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
    End Sub

	Private Sub frmLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		' --- Default erstes ROBO Interface an USB ---
		cboPortName.SelectedIndex = 0
		canvas = picMouse.CreateGraphics()
		mitte = picMouse.Height / 5
		mitteOben = (picMouse.Height - mitte) / 2
		MitteUnten = (picMouse.Height + mitte) / 2
		mitteLinks = (picMouse.Width - mitte) / 2
		mitteRechts = (picMouse.Width + mitte) / 2
		mouseX = mitteLinks + 1
		mouseY = mitteOben + 1
	End Sub

	Private Sub frmClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
		If cmdEnde.Text = "&HALT" Then e.Cancel = True
	End Sub

#End Region

	Private Sub picMouse_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles picMouse.MouseMove
		mouseX = e.X
		mouseY = e.Y
	End Sub

	Private Sub picMouse_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picMouse.MouseLeave
		mouseX = mitteLinks + 1
		mouseY = mitteOben + 1
	End Sub
End Class
